package iteriere;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Consumer;
import java.util.Comparator;

import java.util.NoSuchElementException;


public interface LL<E>{
  static public final record Nil<E>() implements LL<E>{
    @Override public String toString(){return "[]";}
  }





  static public final record Cons<E>(E hd,LL<E> tl) implements LL<E>{
    @Override public String toString(){return show();}
  }





  default boolean isEmpty(){return this instanceof Nil;}





  default E head(){
    if (this instanceof Cons<E> c) return c.hd();
    throw new NoSuchElementException("head on empty list");
  }




  default LL<E> tail(){
    if (this instanceof Cons<E> c) return c.tl();
    throw new NoSuchElementException("tail on empty list");
  }




  static final LL nil = new Nil<>();
  static <E>LL<E> nil(){return nil;}



  static <E>LL<E> cons(E hd,LL<E> tl){return new Cons<>(hd,tl);}





  static <E>LL<E> of(E...es){
    LL<E> r = nil();
    for (int i=es.length-1;i>=0;i--) r = cons(es[i],r);
    return r; 
  }




  default String show(){
    StringBuffer result = new StringBuffer("[");
    boolean first = true;
    for (var it = this;!it.isEmpty();it=it.tail()){
      if (first) first = false;else result.append(", ");
      result.append(it.head());
    }
    result.append("]");
    return result.toString();
  }

}
